
public class TransCalculator
{
    //Transform integer to Binary(Integer Array Format)
    public int[] integerToBinary(int input)
    {
        int result[] = new int[32];
        int shifter = 1;
        boolean isNegative = false;
    
        //Controll Boundary values
        if(input == Integer.MAX_VALUE || input == Integer.MIN_VALUE+1)
            shifter = 2;
        else if (input == Integer.MIN_VALUE)
        {
            result[result.length-1] = 1;
            return result;
        }
       
        if(input<0)//Check if integer is negative
            isNegative = true;
        
        input = Math.abs(input);//Make it positive so we can get the binary form
        
        for(int i=result.length-shifter; i>=0; i--)
        {
            if(((int)Math.pow(2,i)) <= input)
            {
                result[i] = 1;
                input -= ((int)Math.pow(2,i));
            }
            else
                result[i] = 0;
        }
        
        if(isNegative)
            result = twoComplement(result);//Get 2's complete if it is negative
        
        return result;
    }//integerTo Binary()
    
    //2'S Complement
    public int[] twoComplement(final int input[])
    {
        for(int i=0; i<input.length; i++)
        {
            if(input[i]==0)
                input[i] = 1;
            else
                input[i] = 0;
        }
        
        //Add 1 to first digit
        for(int i=0; i<input.length; i++)
        {
            if(input[i] == 1)
                input[i] = 0;
            else
            {
                input[i] = 1;
                break;
            }    
        }
        
        return input;
    }//twoComplement()
    
    //Transform Binary to Integer(Decimal)
    public int binaryToInteger(final int input[])
    {
        int tempInput[] = new int[32];
        tempInput = (int[]) input.clone();
        int result=0;
        boolean negative = false;
        
        if(input[input.length-1] == 1) //Controll if number is negative
        {
            negative = true;
            tempInput = twoComplement(tempInput);// Two's complement taken
        }
        
        for(int i=0; i<input.length; i++)
        {
            if(negative)
                result -= Math.pow(2,i)*tempInput[i];
            else
                result += Math.pow(2,i)*tempInput[i];
        }
              
        return result;
    }//binaryToInteger()
    
    //Transform Binary To Hexadecimal
    public String binaryToHex(final int input[])
    {
        String result = "";
        boolean set = true;//To delete unnecessary 0 from the result string
        
        for(int i=input.length-1; i>=0; i=i-4)
        {
            int temp=0;
            //Add them 4 digit by 4 digit.
            temp = input[i]*8+input[i-1]*4+input[i-2]*2+input[i-3]*1;
           
            if(temp == 0 && set)//Delete unnecessary Zero digits
                continue;//Jump over next steps
            else
                set = false;
            
            if(temp == 10) result +=      'A';
            else if(temp == 11) result += 'B';
            else if(temp == 12) result += 'C';
            else if(temp == 13) result += 'D';
            else if(temp == 14) result += 'E';
            else if(temp == 15) result += 'F';
            else                result += temp;
        }
        
        if(result.length() == 0)
            return "0";
        
        return result;
    }//binaryToHex()
    
    //Transform Binary to Octal
    public String binaryToOctal(final int input[])
    {
        String result  = "";
        String finalResult = ""; //Final result. No unnecessary Zero digits
        
        for(int i=0; i<input.length; i=i+3)
        {
            int temp = 0;
            for(int j=0; j<3; j++)
            {
                //Add them 3 digit by 3 digit.
                if(i+j >= input.length)
                    break;
                temp += input[i+j]*Math.pow(2,j);
            }
            result += temp;
        }
        
        boolean set = true;//To delete unnecessary 0 from the result string
        for(int i=result.length()-1; i>=0; i--)
        {
            if(Integer.parseInt(result.charAt(i)+"") == 0 && set)
                continue;
            else
                set = false;
            
            finalResult += result.charAt(i);
        }
        
        return finalResult;
    }//binaryToOctal
    
    //Transform Binary To ASCII character
    public String binaryToAscii(final int input[])
    {
        String temp = "";
        char ch[]  = new char[4];
        String result = "";
        
        for(int i=input.length-1,k=0; i>=0; i=i-8,k++)
        {
            temp = "";
            for(int j=0; j<8; j++)
                temp += input[i-j];
            
            ch[k] = (char)Integer.parseInt(temp,2);//Get them char by char
        }
  
        return result = ch[0]+" "+ch[1]+" "+ch[2]+" "+ch[3]+" ";
    }//binaryToAscii()
    
    //Transform Octal to Binary
    public int[] octalToBinary(String input)
    {
        int result[] = new int[32];
        
        for(int i=input.length()-1,k=0; i>=0; i--,k=k+3)
        {
            int temp = Integer.parseInt(input.charAt(i)+"");
            
            for(int j=2; j>=0; j--)
                if(temp>=Math.pow(2,j))
                {
                    temp -= Math.pow(2,j);
                    result[k+j]  = 1;
                }    
        }
        
        return result;
    }// octalToBinary()
    
    //Transform Hexadecimal to Binary
    public int[] hexToBinary(String input)
    {
        int result[] = new int[32];
        
        for(int i=input.length()-1,k=0; i>=0; i--,k=k+4)
        {
            int temp;
            
            if(input.charAt(i) == 'A')      temp = 10;
            else if(input.charAt(i) == 'B') temp = 11;
            else if(input.charAt(i) == 'C') temp = 12;
            else if(input.charAt(i) == 'D') temp = 13;
            else if(input.charAt(i) == 'E') temp = 14;
            else if(input.charAt(i) == 'F') temp = 15;
            else temp = Integer.parseInt(input.charAt(i)+"");
            
            for(int j=3; j>=0; j--)
                if(temp>=Math.pow(2,j))
                {
                    temp -= Math.pow(2,j);
                    result[k+j]  = 1;
                }    
        }
        
        return result;
    }//hexToBinary()
    
    //Transform ASCII to Binary
    public int[] asciiToBinary(String input)
    {
        int result[] = new int[32];
        
        for(int i=input.length()-1,k=0; i>=0; i--,k=k+8)
        {
            int temp = (int)input.charAt(i);
            
            for(int j=7; j>=0; j--)
                if(temp>=Math.pow(2,j))
                {
                    temp -= Math.pow(2,j);
                    result[k+j]  = 1;
                }    
        }
      
        return result;
    }//asciiToBinary()
    
    
}//end of TransCalculator class
